unit Unit2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, _3DR, ExtCtrls, StdCtrls, Spin, MPlayer, Gauges;

type
  Tform2 = class(TForm)
    Timer1: TTimer;
    MediaPlayer1: TMediaPlayer;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Private declarations }
    R3dRC : TR3dHandle;
    hdc3dr : HDC;
    frame : integer;
    procedure Render;
    procedure RenderTri(cx, cy, rot, scale : single);
        procedure RenderMain(cx, cy, rot, scale : single);
  public
    procedure Create3d(Sender: TObject);
    { Public declarations }
  end;

var
  form2: Tform2;

implementation

{$R *.DFM}
var mx,my:word;
var kl,kr,win,ending:byte;
var hits,score,level,lives:longint;
var xran,yran:longint;

var
  MEDIUM_GREY :longint;

  numtri :longint;
  triscale :longint;       trim:longint;
  numsides :longint;


  numtri2 :longint;
  triscale2 :longint;
  numsides2 :longint;

  const maxtri=255;

  alpha=$8000;

var
  tri : array[0..maxtri-1] of record
    xx,yy,rr : single;
    xvel, rvel,yvel : single;
  end;

  var
  tri2 : array[0..maxtri-1] of record
    xx,yy,rr : single;
    xvel, rvel,yvel,state : single;

  end;

function DwordToFixedPt(D : longint) : TFixed32;
begin
  Result := TFixed32((D and $FFFF) shl 16);
end;

function FloatToFixedPt(F : single) : TFixed32;
begin
  Result := TFixed32(round(F*65536.0));
end;

const
  VertexData : array[0..4] of TR3dFixedVtxClr = (
  (* x y z  r      g      b       a  *)
    (x:0; y:0; z:0; r:$FFFF; g:$0000; b:$0000; a:ALPHA),
    (x:0; y:0; z:0; r:$0000; g:$FFFF; b:$0000; a:ALPHA),
    (x:0; y:0; z:0; r:$0000; g:$0000; b:$FFFF; a:ALPHA)    ,
    (x:0; y:0; z:0; r:$F0ff; g:$ff00; b:$FF0F; a:ALPHA)  ,
    (x:0; y:0; z:0; r:$F00f; g:$ff00; b:$0F0F; a:ALPHA)
  );



    MainVertexData : array[0..8] of TR3dFixedVtxClr = (
  (* x y z  r      g      b       a  *)
    (x:0; y:0; z:0; r:$FFFF; g:$0000; b:$0000; a:ALPHA),
    (x:0; y:0; z:0; r:$0000; g:$FFFF; b:$0000; a:ALPHA),
    (x:0; y:0; z:0; r:$0000; g:$0000; b:$FFFF; a:ALPHA)    ,
    (x:0; y:0; z:0; r:$F0ff; g:$ff00; b:$FF0F; a:ALPHA)  ,
    (x:0; y:0; z:0; r:$F00f; g:$ff00; b:$0F0F; a:ALPHA) ,
        (x:0; y:0; z:0; r:$F00f; g:$ff00; b:$0F0F; a:ALPHA)  ,
            (x:0; y:0; z:0; r:$F00f; g:$ff00; b:$0F0F; a:ALPHA),
                (x:0; y:0; z:0; r:$F00f; g:$ff00; b:$0F0F; a:ALPHA),
                    (x:0; y:0; z:0; r:$F00f; g:$ff00; b:$0F0F; a:ALPHA)

  );


procedure incs; begin
hits:=hits+1;

               if(score>level)then begin
              if(level=20)then begin            with form2 do begin
         mediaplayer1.stop;
               mediaplayer1.close;
    mediaplayer1.filename:='stage1.mod';
               mediaplayer1.open;mediaplayer1.play;


                          end;end;

                                        if(level=ending)then begin            with form2 do begin
         mediaplayer1.stop;
               mediaplayer1.close;
    mediaplayer1.filename:='cool.mod';
               mediaplayer1.open;mediaplayer1.play;


                          end;end;

               score:=0;      level:=level+1;

yran:=1+random(LEVEL);
  numtri := numtri+1;        {number}

  triscale := 2+random(Level);     {size}
if(level<10)then begin triscale:=20+random(20); end else
if(level<20)then begin triscale:=5+random(35); end;
  numsides := 3+random(5);
form2.Create3d(nil);
     end;
  inc(score);
  form2.caption:=inttostr(level)+'  '+inttostr(lives);
                 if(lives<1)then begin
                 form2.caption:='Game Over';
                 end;
                 if(win=1)then begin
                 form2.caption:='You win';
                 end;
  end;






procedure Tform2.Create3d(Sender:TObject);
var
  i : integer;
begin
if(level>30)then begin
      for i:=0 to numtri-1 do begin

     VertexData[i].r:=random($FFFF);VertexData[i].g:=random($FFFF);VertexData[i].b:=random($FFFF);
         end;
         end;
      i:=0;

  if R3dRC = 0 then
    raise Exception.Create('Could not create 3DR context');
  R3dSetState(R3DRC, R3D_STA_BG_COLOR, {MEDIUM_GREY}0);
  R3dSetState(R3DRC, R3D_STA_ENABLES,  R3D_SE_SHADING);
  R3dSetState(R3DRC, R3D_STA_ENABLES,  R3D_SE_CLIPPING);
  R3dSetState(R3DRC, R3D_STA_ENABLES,  R3D_SE_ANTIALIASING);

if(random(level)>1)then  begin R3dSetState(R3DRC, R3D_STA_ENABLES,  R3D_SE_Z_BUFFERING);end;
R3dSetState(R3DRC, R3D_STA_ENABLES,  R3D_SE_BLENDING);
if(lives<1)then  begin R3dSetState(R3DRC, R3D_STA_SRC_BLEND_FUNCTION,  R3D_BF_SRC_ALPHA);end;
if(random(level)>10)then R3dSetState(R3DRC, R3D_STA_DST_BLEND_FUNCTION,  R3D_BF_SRC_ALPHA_INV);



  FillChar(tri, sizeof(tri), 0);
  for i := 0 to numtri-1 do with tri[i] do begin
    xx := random(Width)+0;
    yy := 0;
    rr := random*pi;
    xvel := 0;
    rvel := (random*pi/16);
    yvel := random*yran;
  end;





end;

procedure Tform2.FormCreate(Sender: TObject);
    var i:integer;
begin
ending:=50;
win:=0;

hits:=0;
lives:=100;
mediaplayer1.play;
level:=0;
xran:=1;
yran:=1;
trim:=0;
  MEDIUM_GREY := $FF808080;

  numtri := 1;
  triscale := 20;
  numsides := 4;


  numtri2 :=4;
  triscale2 := 10;
  numsides2 := 3;  

  hDC3DR := GetDC(Handle);
  R3dRC := R3dCreateRC(TR3dHandle(hDC3DR), 0);
      FillChar(tri2, sizeof(tri2), 0);
  for i := 0 to numtri2-1 do with tri2[i] do begin
    xx := random(Width)+0;
    yy := 0;
    rr := random*pi;
    xvel := 0;
    rvel := (random*pi/16);
    yvel := random;
  end;
   Create3d(Sender);
  Timer1.Enabled := true;
end;

procedure Tform2.RenderTri(cx, cy, rot, scale : single);
var
  r,s1,c1 : single;
  i : integer;
begin
  for i := 0 to NumSides-1 do begin
    r := rot + (3.141592*2/NumSides)*i;
    s1 := sin(r)*scale;
    c1 := cos(r)*scale;
    with VertexData[i] do begin
      x := FloatToFixedPt(cx+s1);
      y := FloatToFixedPt(cy+c1);
      z := i;
    end;
  end;

  R3dPrimitive(   R3DRC,
                  R3D_PKT_POLYGON,
                  R3D_VI_COLOR,
                  numsides,
                  sizeof(TR3dFixedVtxClr),
                  @VertexData);



end;



procedure Tform2.RenderMain(cx, cy, rot, scale : single);
var
  r,s1,c1 : single;
  i : integer;
  const nu=3;
begin
 for i := 0 to nu-1 do begin
    r := rot + (3.141592*2/nu)*i;
    s1 := sin(r)*scale;
    c1 := cos(r)*scale;
    with MainVertexData[i] do begin
      x := FloatToFixedPt(cx+s1);
      y := FloatToFixedPt(cy+c1);
      z := 3;
    end;
  end;

 { MainVertexData[0].r:=$FFFF;MainVertexData[0].g:=$FFFF;MainVertexData[0].b:=$0000;
    MainVertexData[1].r:=$FFFF;MainVertexData[1].g:=$0000;MainVertexData[1].b:=$0000;
      MainVertexData[2].r:=$FFFF;MainVertexData[2].g:=$FFFF;MainVertexData[2].b:=$0000;
  }

  R3dPrimitive(   R3DRC,
                  R3D_PKT_POLYGON,
                  R3D_VI_COLOR,
                  nu,
                  sizeof(TR3dFixedVtxClr),
                  @MainVertexData);
end;

procedure Tform2.Render;
var
  i  :integer;
begin
 R3dClearBuffers(R3DRC, R3D_CI_DRAW_BUFFER);

   for i := 0 to numtri2-1 do with tri2[i] do begin
         RenderMain(tri2[i].xx, tri2[i].yy, tri2[i].rr, triscale2);
end;
  for i := 0 to numtri-1 do with tri[i] do begin
    RenderTri(xx, yy, rr, triscale);
    xx := xx + xvel;
    yy := yy + yvel;
    rr := rr + rvel;


  if(PtInRect(rect(round(xx-triscale-trim),round(yy-triscale-trim),round(xx+triscale+trim),round(yy+triscale+trim)),    point(round(tri2[0].xx),round(tri2[0].yy)))) then begin
    {0 got hit by i}
     MainVertexData[0].r:=random($FFFF);MainVertexData[0].g:=random($FFFF);MainVertexData[0].b:=random($FFFF);
    MainVertexData[1].r:=random($FFFF);MainVertexData[1].g:=random($FFFF);MainVertexData[1].b:=random($FFFF);
      MainVertexData[2].r:=random($FFFF);MainVertexData[2].g:=random($FFFF);MainVertexData[2].b:=random($FFFF);
     lives:=lives-1;
     if(lives=0)then begin
              mediaplayer1.stop;
               mediaplayer1.close;
    mediaplayer1.filename:='died.mod';
               mediaplayer1.open;mediaplayer1.play;
               create3d(nil);
               end;
end;

  if(PtInRect(rect(round(xx-triscale-trim),round(yy-triscale-trim),round(xx+triscale+trim),round(yy+triscale+trim)),    point(round(tri2[1].xx),round(tri2[1].yy)))) then begin
    {1 got hit by i}
    yy:=-50;
    xx:=random(width);
      yvel := random*yran;
      randomize;
    tri2[1].yy:=-100;
    incs;

end;  if(PtInRect(rect(round(xx-triscale-trim),round(yy-triscale-trim),round(xx+triscale+trim),round(yy+triscale+trim)),    point(round(tri2[2].xx),round(tri2[2].yy)))) then begin
    {2 got hit by i}
     yy:=-50;
    xx:=random(width);
      yvel := random*yran;
      randomize;
    tri2[2].yy:=-100;
    incs;

end;
    if(PtInRect(rect(round(xx-triscale-trim),round(yy-triscale-trim),round(xx+triscale+trim),round(yy+triscale+trim)),    point(round(tri2[3].xx),round(tri2[3].yy)))) then begin
    {3 got hit by i}
     yy:=-50;
    xx:=random(width);
    
      yvel := random*yran;
      randomize;
    tri2[3].yy:=-100;
    incs;


end;


    if(yy>height)then begin yy:=-52;xx:=random(width);
    {i fall off screen code}
        xx := random(Width)+0;
    yy := 0;
    rr := random*pi;
    xvel := 0;
    rvel := (random*pi/16);
    yvel := random*yran;
      randomize;
    end;
  end;



 R3dSwapBuffers( R3DRC, 0);

end;

procedure Tform2.FormPaint(Sender: TObject);
begin

  Render;

end;

procedure Tform2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  R3dDeleteRC(R3DRC);
  ReleaseDC(Handle, hDC3DR);
end;

procedure Tform2.Timer1Timer(Sender: TObject);
begin
if(lives>0)and(level>ending)then win:=1;
if(kl=1)then begin mx:=mx-3;end;
if(kr=1)then begin mx:=mx+3;end;


if(tri2[0].xx<mx)then tri2[0].xx:=tri2[0].xx+3;
if(tri2[0].xx>mx)then tri2[0].xx:=tri2[0].xx-3;
tri2[0].yy:=(height)-triscale2*numsides+4;


if(tri2[1].yy<-30)then begin tri2[1].state:=0;end else begin tri2[1].yy:=tri2[1].yy-1;end;
if(tri2[2].yy<-30)then begin tri2[2].state:=0;end else begin tri2[2].yy:=tri2[2].yy-3;end;
if(tri2[3].yy<-30)then begin tri2[3].state:=0;end else begin tri2[3].yy:=tri2[3].yy-7;end;
 tri2[0].rr:=tri2[0].rr-(3.14 / 64);

  inc(frame);
  Render;
 
end;

procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
mx:=x;
my:=y;
end;

procedure TForm2.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

if(button=mbleft)and(tri2[1].state=0)then begin
        tri2[1].xx:=tri2[0].xx;
        tri2[1].yy:=tri2[0].yy;
        tri2[1].state:=1;
end;
if(button=mbright)and(tri2[2].state=0)then begin
         tri2[2].xx:=tri2[0].xx;
         tri2[2].yy:=tri2[0].yy;
         tri2[2].state:=1;
end;
if(button=mbmiddle)and(tri2[3].state=0)then begin
         tri2[3].xx:=tri2[0].xx;
         tri2[3].yy:=tri2[0].yy;
         tri2[3].state:=1;
end;

end;

procedure TForm2.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

if(key=74)then begin kl:=0;end;
if(key=75)then begin kr:=0;end;

if(key=83)and(tri2[1].state=0)then begin
        tri2[1].xx:=tri2[0].xx;
        tri2[1].yy:=tri2[0].yy;
        tri2[1].state:=1;
end;
if(key=68)and(tri2[2].state=0)then begin
         tri2[2].xx:=tri2[0].xx;
         tri2[2].yy:=tri2[0].yy;
         tri2[2].state:=1;
end;
if(key=70)and(tri2[3].state=0)then begin
         tri2[3].xx:=tri2[0].xx;
         tri2[3].yy:=tri2[0].yy;
         tri2[3].state:=1;
end;
end;

procedure TForm2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if(key=74)then begin kl:=1;end;
if(key=75)then begin kr:=1;end;
end;

end.
